<? SESSION_START(); ?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>error checking</title>
  <link rel="stylesheet" href="css/styles.css">
</head>
<body> 
<?php

                if(!ISSET($_POST['submit'])) {
                    //The form has not been submitted
                    form();
                }else{
                    //Add data sanatization here using filters
                    //$email = filter_var($_POST['email'], FILTER_UNSAFE_RAW);
                    $email = filter_var($_POST['email'], FILTER_SANITIZE_EMAIL);
                    $password = filter_var($_POST['password'], FILTER_SANITIZE_FULL_SPECIAL_CHARS);
                    $email_error = validate($email,'email');
                    $password_error = validate($password,'password');
                   
                if(ISSET($email_error) || ISSET($password_error)){
                    $error = array_merge($email_error,$password_error);
                    //there must be an error.
                    //do error handling here
                    echo "<div class='msgBox error'>";
                    echo "<h2>Oh no!</h2>";
                    foreach($error as $val){
                        echo "<p>". $val . "</p>";
                }
                echo "</div>";
                form();
            }else{
                //no errors,continue as expected
                echo "<p>No errors, continue.</p>";     //jelly bean happens here after email check//
                var_dump($_POST);
            }
        }
        
            function form(){
                    
            ?>
        <form method ="post" action ="<?$_SERVER['PHP_SELF']?>">
        <p><label for="email">email address:</label><input type="text" name="email" id="email" placeholder="Enter email address"></p>
        <p><label for="password">password: </label><input type="password" name="password" id="password" placeholder="Enter your password"></p>
        <p><button type="submit" value="submit " name="submit">Log In</button></p>
        </form>
        <?
        }
        //validate($email,'email');
        function validate($data,$validation_type = 'text'){
            $data = trim($data);
            $error = null;
            if($validation_type == 'email'){
                //do email validation here
                if($data==""){
                    $error[] = "No email address entered. ";
                }
                if(!str_contains($data,"@")){
                    //check to see if there is a '@' in the returned value, and if not return an error
                    $error[] = "Malformed email address.You need to include an '@' .";
                }
                if (strlen($data)<7){
                    //check to see if there is a @ in the retturned value and if not return an error.
                    $error[] = "Your email address is far too short.Please try again. ";
                }
            }elseif($validation_type == 'password'){
                //do password validation
                if(strlen($data)<4){
                    //check to see if there ia a '@' in the returned value, and if not return an error
                    $error[] = "The password entered is too short.";
                }
            }else{
                    //do general validation here

                }
                return $error;
            }
        
    ?>

    </body>
    </html>